/*
 * ClientForm.java
 *
 * Created on 16 de Novembro de 2006, 16:35
 */

package client;

import client.JpegFileFilter;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Image;
import java.io.File;
import java.util.Vector;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

/**
 *
 * @author  Eduardo
 */
public class ClientForm extends javax.swing.JFrame {
    
    //cliente principal
    MainClient c;
    //flag de aviso se esta ligado ao servidor
    boolean conected = false;
    
    //contactos que o cliente tem online
    Vector ContactsOn = new Vector();
    //contactos que o cliente tem offline
    Vector ContactsOff = new Vector();
    //contacto que est selecionado na lista
    Contact Selected = null;
    
    
    /** Creates new form ClientForm */
    public ClientForm() {
        initComponents();
        ScrollPane.getVerticalScrollBar().setUnitIncrement(5);
        
        //inicializar painel de mostrar avatar
        ((ImagePanel)Image).SetFather(this);
        RepaintArea();
        
        try{
            //inicializar cliente
            c = new MainClient(this);
        }catch(Exception e){
            ShowMessage( e.getMessage() );
        }
        
    }
    
    //mostrar mensagem de erro
    public void ShowMessage(String msg){
        JOptionPane.showMessageDialog(this, msg, "ERRO", JOptionPane.ERROR_MESSAGE);
    }
    
    //inicializar contactos na lista de desenho
    public void SetContacts(Vector on, Vector off, Contact c){
        ContactsOn = on;
        ContactsOff = off;
        ((ScrollArea)DrawArea).setContacts(on, off);
        ((ScrollArea)DrawArea).SetFather(this);
        Selected = null;
    }
    
    //redesenhar area de desenho
    public void RepaintArea(){
        DrawArea.repaint();
        int altura = 500;
        int largura = 0;
        DrawArea.setPreferredSize( new Dimension(largura, altura) );
        DrawArea.setSize(largura, altura);
        ScrollPane.doLayout();
    }
    
    //obter avatar em forma de imageicon
    public ImageIcon GetImageIcon(){
        ImageIcon img = new ImageIcon();
        img.setImage( ((ImagePanel)Image).GetImage() );
        return img;
    }
    
    //obter avatar em forma de imagem
    public Image GetImage(){
        return ((ImagePanel)Image).GetImage();
    }
    
    //escolher directoria onde esta o ficheiro com o avatar
    public void SetImage(String path){
        ((ImagePanel)Image).SetImage( path );
        RepaintArea();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        PopupMenu = new javax.swing.JPopupMenu();
        MenuItemMessage = new javax.swing.JMenuItem();
        MenuItemBlock = new javax.swing.JMenuItem();
        MenuItemDelete = new javax.swing.JMenuItem();
        ScrollPane = new javax.swing.JScrollPane();
        DrawArea = new ScrollArea();
        NameField = new javax.swing.JTextField();
        button1 = new java.awt.Button();
        jLabel1 = new javax.swing.JLabel();
        button2 = new java.awt.Button();
        Image = new ImagePanel();
        button3 = new java.awt.Button();
        IPField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();

        MenuItemMessage.setText("Enviar Mensagem");
        MenuItemMessage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuItemMessageActionPerformed(evt);
            }
        });

        PopupMenu.add(MenuItemMessage);

        MenuItemBlock.setText("Bloquear");
        MenuItemBlock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuItemBlockActionPerformed(evt);
            }
        });

        PopupMenu.add(MenuItemBlock);

        MenuItemDelete.setText("Eliminar Contacto");
        MenuItemDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuItemDeleteActionPerformed(evt);
            }
        });

        PopupMenu.add(MenuItemDelete);

        setTitle("Messenger");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        DrawArea.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                DrawAreaMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout DrawAreaLayout = new org.jdesktop.layout.GroupLayout(DrawArea);
        DrawArea.setLayout(DrawAreaLayout);
        DrawAreaLayout.setHorizontalGroup(
            DrawAreaLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 469, Short.MAX_VALUE)
        );
        DrawAreaLayout.setVerticalGroup(
            DrawAreaLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 434, Short.MAX_VALUE)
        );
        ScrollPane.setViewportView(DrawArea);

        NameField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                NameFieldActionPerformed(evt);
            }
        });

        button1.setLabel("Iniciar Sessao");
        button1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button1ActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 3, 14));
        jLabel1.setText("Nome");

        button2.setEnabled(false);
        button2.setLabel("Adicionar Contacto");
        button2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button2ActionPerformed(evt);
            }
        });

        Image.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                ImageMouseMoved(evt);
            }
        });
        Image.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ImageMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout ImageLayout = new org.jdesktop.layout.GroupLayout(Image);
        Image.setLayout(ImageLayout);
        ImageLayout.setHorizontalGroup(
            ImageLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 101, Short.MAX_VALUE)
        );
        ImageLayout.setVerticalGroup(
            ImageLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 101, Short.MAX_VALUE)
        );

        button3.setLabel("Sair");
        button3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button3ActionPerformed(evt);
            }
        });

        IPField.setText("127.0.0.1");

        jLabel2.setFont(new java.awt.Font("Tahoma", 3, 14));
        jLabel2.setText("Servidor");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .addContainerGap()
                        .add(ScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 336, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(layout.createSequentialGroup()
                                .add(26, 26, 26)
                                .add(Image, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(layout.createSequentialGroup()
                                .addContainerGap()
                                .add(button2, 0, 0, Short.MAX_VALUE)))
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 15, Short.MAX_VALUE)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                        .add(jLabel1)
                                        .add(12, 12, 12)
                                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                                .add(button1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                            .add(org.jdesktop.layout.GroupLayout.LEADING, NameField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 151, Short.MAX_VALUE)))
                                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                        .add(jLabel2)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(IPField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 107, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .add(layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(button3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 64, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(NameField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(19, 19, 19)
                        .add(button1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(button3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(Image, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(26, 26, 26)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabel2)
                        .add(IPField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(button2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(ScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 415, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void MenuItemMessageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MenuItemMessageActionPerformed
// TODO add your handling code here:
        //abrir janela de conversacao caso apanas o conatcto selecioando
        //estiver online e nao estiver bloqueado
        if ( ContactsOn.contains(Selected) && !Selected.Blocked )
            c.OpenTalkWindow(Selected.Name);
    }//GEN-LAST:event_MenuItemMessageActionPerformed
    
    private void ImageMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ImageMouseClicked
// TODO add your handling code here:
        
        //filtros para a escolha de imagem
        JFileChooser chooser = new JFileChooser(System.getProperty("user.dir"));
        FileFilter JPG = new JpegFileFilter();
        FileFilter PNG = new PngFileFilter();
        chooser.setAcceptAllFileFilterUsed(false);
        chooser.addChoosableFileFilter(PNG);
        chooser.addChoosableFileFilter(JPG);
        chooser.setFileFilter(JPG);
        // Show dialog; this method does not return until dialog is closed
        
        //abrir caixa de selecao de imagem
        int returnValue = chooser.showOpenDialog(this);
        if( (returnValue == chooser.ERROR_OPTION ) || (returnValue==chooser.CANCEL_OPTION)  )
            return;
        
        //colocar novo avatar no imagepanel
        ((ImagePanel)Image).SetImage( chooser.getSelectedFile().getPath() );
        //enviar novo avatar para todos os seus contactos
        new SendImage ( c, ContactsOn, GetImageIcon() );
        //redesenhar area de desenho
        RepaintArea();
        
    }//GEN-LAST:event_ImageMouseClicked
    
    private void button3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button3ActionPerformed
// TODO add your handling code here:
        //finalizar cliente
        c.ExitClient();
        //fechar a janela
        this.dispose();
    }//GEN-LAST:event_button3ActionPerformed
    
    private void button2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button2ActionPerformed
// TODO add your handling code here:
        //adiconar novo contacto
        String contact=null;
        contact=JOptionPane.showInputDialog(this, "Introduza nome do contacto:", "");
        if ( contact!=null && !contact.equals("") )
            try {
                //ao adicionar se este tiver online adiciona-o
                if ( c.AddContact(contact) )
                    c.AddContactOn(contact);
                else
                    c.AddContactOff(contact);
            } catch (Exception ex) {
                ShowMessage( ex.getMessage() );
                ex.printStackTrace();
            }
        
    }//GEN-LAST:event_button2ActionPerformed
    
    private void NameFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NameFieldActionPerformed
// TODO add your handling code here:
        button1ActionPerformed(null);
    }//GEN-LAST:event_NameFieldActionPerformed
    
    private void button1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button1ActionPerformed
// TODO add your handling code here:
        if (conected){
            //se estiver ligado ao servidor termina sessao
            
            try {
                c.EndClient();
            } catch (Exception ex) {
                ShowMessage(ex.getMessage() );
            }
            //alterar componentes
            NameField.setEnabled(true);
            button2.setEnabled(false);
            button1.setLabel("Iniciar Sessao");
            conected = false;
            //limpar area de desenho da lista
            SetContacts(null, null, null);
            RepaintArea();
            
        }else{
            //ligar ao servidor
            if ( NameField.getText()==null || NameField.getText().equals("") )
                return;
            
            
            try {
                c.ServerIP = IPField.getText();
                //iniciar cliente
                c.StartClient( NameField.getText() );
                NameField.setEnabled(false);            
                button1.setLabel("Terminar Sessao");
                button2.setEnabled(true);
                conected = true;
            } catch (Exception ex) {
                ShowMessage( ex.getMessage() );
                ex.printStackTrace();
            }
            
        }
    }//GEN-LAST:event_button1ActionPerformed
    
    private void ImageMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ImageMouseMoved
// TODO add your handling code here:
        Image.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
    }//GEN-LAST:event_ImageMouseMoved
    
    private void MenuItemDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MenuItemDeleteActionPerformed
// TODO add your handling code here:
        try {
            //remover contacto onde se encontar nos vectores
            if ( c.RemoveContact( Selected.Name ) ){
                System.out.println( Selected.Name );
                ContactsOn.remove(Selected);
                ContactsOff.remove(Selected);
                Selected = null;
                DrawArea.repaint();
            }else
                System.out.println("erro");
        } catch (Exception ex) {
            ShowMessage( ex.getMessage() );
        }
    }//GEN-LAST:event_MenuItemDeleteActionPerformed
    
    private void MenuItemBlockActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MenuItemBlockActionPerformed
// TODO add your handling code here:
        try {
            //bloquear contacto no servidor
            Selected.Blocked = c.BlockContact(Selected.Name);
            //redesenhar area de desenho da lista
            DrawArea.repaint();
        } catch (Exception ex) {
            ShowMessage( ex.getMessage() );
        }
        
    }//GEN-LAST:event_MenuItemBlockActionPerformed
    
    private void DrawAreaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_DrawAreaMouseClicked
// TODO add your handling code here:
        //caso seja doubleclick abrir janela de conversacao
        if ( evt.getClickCount()==2 ){
            MenuItemMessageActionPerformed(null);
            return;
        }
        
        
        int start = 25;
        Selected = null;
        //contar posicoes para saber qual o ocntacto selecionado
        for (int i = 0; i < ContactsOn.size(); i++, start+=28) {
            if ( evt.getY()>start && evt.getY()<start+25 ){
                Selected = (Contact)ContactsOn.get(i);
                
                //se o clique for feito num cliente entao mostra popup de propriedades do contacto
                if ( evt.getButton() != evt.BUTTON1 ){
                    if ( Selected.Blocked )
                        MenuItemBlock.setText("Desbloquear");
                    else
                        MenuItemBlock.setText("Bloquear");
                    PopupMenu.show(DrawArea, evt.getX(), evt.getY());
                }
                break;
            }
        }
        
        //igual mas para contactos que estao offline
        start = 60 + ContactsOn.size()*28;
        for (int i = 0; i < ContactsOff.size(); i++, start+=28) {
            if ( evt.getY()>start && evt.getY()<start+25 ){
                Selected = (Contact)ContactsOff.get(i);
                
                
                if ( evt.getButton() != evt.BUTTON1 ){
                    if ( Selected.Blocked )
                        MenuItemBlock.setText("Desbloquear");
                    else
                        MenuItemBlock.setText("Bloquear");
                    PopupMenu.show(DrawArea, evt.getX(), evt.getY());
                }
                break;
            }
        }
        
        //redesenhar area de desenho da lsita com o novo contacto selecioando
        if ( Selected!=null )
            ((ScrollArea)DrawArea).setSelected(Selected);
        DrawArea.repaint();
        
    }//GEN-LAST:event_DrawAreaMouseClicked
    
    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
// TODO add your handling code here:
        //simular queda de ligacao e nao desligar no servidor
        c.StopClient();
        System.exit(0);
    }//GEN-LAST:event_formWindowClosing
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ClientForm().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel DrawArea;
    private javax.swing.JTextField IPField;
    private javax.swing.JPanel Image;
    private javax.swing.JMenuItem MenuItemBlock;
    private javax.swing.JMenuItem MenuItemDelete;
    private javax.swing.JMenuItem MenuItemMessage;
    private javax.swing.JTextField NameField;
    private javax.swing.JPopupMenu PopupMenu;
    private javax.swing.JScrollPane ScrollPane;
    private java.awt.Button button1;
    private java.awt.Button button2;
    private java.awt.Button button3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    // End of variables declaration//GEN-END:variables
    
}
