/*
 * MainClient.java
 *
 * Created on 9 de Novembro de 2006, 15:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package client;

import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.io.File;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import server.*;
import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.security.Permission;

/**
 *
 * @author Administrator
 */
public class MainClient  extends UnicastRemoteObject implements ServerAcept, ClientAcept {
    
    //ip do servidor
    public static String ServerIP = "127.0.0.1";
    int port = 10001;
    
    
    //url para comunicacao com o servido
    String server_send = "//"+ServerIP+":10000/ServerMethodsServer";
    //url para comunicacao do servidor com o cliente
    String server_acept = "//localhost:10000/ServerAcept";
    //url para comunicacao entre clientes
    String client_acept = "//localhost:10000/ClientAcept";
    //objecto do servidor
    ServerMethods server = null;
    
    String MyName;
    public static final Image DefaultImage =
            Toolkit.getDefaultToolkit().createImage("on.png");
    boolean receiving = false;
    
    //vector com todos os contactos online
    Vector ContactsOn = new Vector();
    //vector com todos os contacots offline
    Vector ContactsOff = new Vector();
    //vector com todas as jaenlas de conversacao activas
    Vector OpenWindows = new Vector();
    //janela do cliente
    ClientForm Client;
    
    
    /** Creates a new instance of MainClient */
    public MainClient(ClientForm c) throws RemoteException {
        
        System.setSecurityManager(new RMISecurityManager(){
            public void checkConnect(String host, int port) {}
            public void checkConnect(String host, int port, Object context) {}
            public void checkPermission(Permission perm) {}});
            
            Client = c;
    }
    
    //inicializar cliente
    public void StartClient(String myname) throws Exception{
        
        MyName = myname;
        Client.SetImage(MyName+".jpg");
        
        //arranjr um porto que nao esteja ocupado
        port = 10001;
        while(true){
            try{
                java.rmi.registry.LocateRegistry.createRegistry(port);
                break;
            }catch(Exception e){
                port++;
            }
        }
        
        //inicializar urls
        server_send = "//"+ServerIP+":10000/ServerMethodsServer";
        server_acept = "//localhost:"+port+"/ServerAcept";
        client_acept = "//localhost:"+port+"/ClientAcept";
        TalkWindow.MyClientAcept = "//localhost:"+port+"/ClientAcept";
        
        
        server = (ServerMethods)Naming.lookup(server_send);
        //server_acept = "//localhost:10000/ServerAcept"+MyName;
        Naming.rebind(server_acept, this);
        Naming.rebind(client_acept, this);
        //////////
        server.Register(MyName);
        
        //ligar-se ao sevidor
        server.SetOnline(MyName, port);
        //receber todos os contacots
        ReceiveContacts();
        TalkWindow.SetContactsOn(ContactsOn);
        
        Client.setTitle("MSN - "+MyName);
        //receber imagens dos contacots
        new ReceiveImage(this, ContactsOn);
        
    }
    
    public void EndClient() throws Exception{
        
        if (server==null)
            return;
        
        //avisar servidor da saida
        server.SetOffline(MyName);
        //tirar objectos do registo
        Naming.unbind(server_acept);
        Naming.unbind(client_acept);
        server = null;
        
        //fechar todas as janelas de conversacao
        for (int i = 0; i < OpenWindows.size(); i++)
            ((TalkWindow)OpenWindows.get(i)).dispose();
        
        //reiniciar area de desenho da lista
        Client.SetContacts(null, null, null);
        Client.RepaintArea();
    }
    
    //teminar cleiente
    public void ExitClient(){
        try {
            EndClient();
        } catch (Exception ex) {}
        System.exit(0);
    }
    
    //fechar cliente
    public void StopClient(){
        System.exit(0);
    }
    
    //redesenhar area da lista
    public void RepaintArea(){
        Client.RepaintArea();
    }
    
    //receber contactos do servidor
    public void ReceiveContacts() throws RemoteException{
        
        Vector aux = server.GetContacts(MyName);
        if (server==null){
            Client.ShowMessage("No est registado no servidor");
            return;
        }
        
        //apanhar todos os contactos recebidos do servidor
        //e se estes estam bloqueados ou online
        ContactsOn = new Vector();
        ContactsOff = new Vector();
        for (int i = 0; i < aux.size(); i++) {
            
            char state = ((String)aux.get(i)).charAt(0);
            boolean blocked = ((String)aux.get(i)).charAt(1)=='b';
            int ip_end = ((String)aux.get(i)).indexOf(":");
            String IP = ((String)aux.get(i)).substring(2, ip_end);
            int port_end = ((String)aux.get(i)).indexOf(":", ip_end+1);
            int porto = Integer.parseInt(  ((String)aux.get(i)).substring(ip_end+1, port_end)  );
            String Name = ((String)aux.get(i)).substring(port_end+1);
            
            if (state=='<')
                ContactsOff.add( new Contact(Name, blocked, null) );
            else{
                ContactsOn.add( new Contact(Name, blocked, null) );
                ((Contact)ContactsOn.lastElement()).ClientAcept = "//"+IP+":"+porto+"/ClientAcept";
            }
        }
        
        //redesenhar area
        Client.SetContacts(ContactsOn, ContactsOff, null);
        Client.RepaintArea();
        
    }
    
    //bloquear contactos e fechar janelas em que a conversacao estava activa
    public boolean BlockContact(String contact) throws Exception{
        if ( server.BlockContact(MyName, contact) ){
            for (int i = 0; i < OpenWindows.size(); i++)
                if ( ((TalkWindow)OpenWindows.get(i)).Contacts.contains(contact) )
                    ((TalkWindow)OpenWindows.get(i)).dispose();
            return true;
        }
        return false;
    }
    
    //remover contacto
    public boolean RemoveContact(String contact) throws Exception{
        return server.RemoveContact(MyName, contact);
    }
    
    //adicionar contacto
    public boolean AddContact(String contact) throws Exception{
        if ( !server.IsRegisted(contact) )
            throw new Exception("O contacto nao esta regitado no servidor");
        
        return server.AddContact(MyName, contact);
    }
    
    
    
    
    
    //adiconar novo contacto offline
    public void AddContactOff(String contact){
        if ( ContainsContact(contact) )
            return;
        ContactsOff.add( new Contact(contact, false, null) );
        Client.RepaintArea();
    }
    
    //adicionar novo contacto online
    //receber tb os seus avatars
    public void AddContactOn(String contact){
        if ( ContainsContact(contact) )
            return;
        ContactsOn.add( new Contact(contact, false, null) );
        Vector v = new Vector();
        v.add( ContactsOn.lastElement() );
        new ReceiveImage(this, v);
        try {
            ((Contact)ContactsOn.lastElement()).ClientAcept = server.GetClientAcept(contact);
            
        } catch (RemoteException ex) {
            ContactsOn.remove( ContactsOn.lastElement() );
            Client.ShowMessage( ex.getMessage() );
        }
        Client.RepaintArea();
    }
    
    //verificar se contem contacto
    public boolean ContainsContact(String contact){
        for (int i = 0; i < ContactsOn.size(); i++)
            if ( ((Contact)ContactsOn.get(i)).Name.equals( contact ) )
                return true;
        
        for (int i = 0; i < ContactsOff.size(); i++)
            if ( ((Contact)ContactsOff.get(i)).Name.equals( contact ) )
                return true;
        
        return false;
    }
    
    //obter contacto pelo nome
    public Contact GetContact(String contact){
        for (int i = 0; i < ContactsOn.size(); i++)
            if ( ((Contact)ContactsOn.get(i)).Name.equals( contact ) )
                return (Contact)ContactsOn.get(i);
        
        for (int i = 0; i < ContactsOff.size(); i++)
            if ( ((Contact)ContactsOff.get(i)).Name.equals( contact ) )
                return (Contact)ContactsOn.get(i);
        
        return null;
    }
    ////////////////////////////////////////////////////////////////////////////
    
    //obter se esta ou nao online
    public boolean GetStatus(){
        if (server!=null)
            return true;
        return false;
    }
    
    //aviso da entrada de um novo cliente
    public void SetContactOn(String contact, String ClientAcept) throws RemoteException {
        
        for (int i = 0; i < ContactsOff.size(); i++){
            if ( ((Contact)ContactsOff.get(i)).equals(contact) ){
                ContactsOn.add( ContactsOff.remove(i) );
                //receber url
                ((Contact)ContactsOn.lastElement()).ClientAcept = ClientAcept;
                Vector v = new Vector();
                v.add( ContactsOn.lastElement() );
                //receber seu avatar
                new ReceiveImage(this, v);
            }
        }
        
        Client.RepaintArea();
        //abrir janela de entrada
        new ContactEntrance(contact).setVisible(true);
        
    }
    
    //avisar da saida de um cliente
    public void SetContactOff(String contact) throws RemoteException {
        
        for (int i = 0; i < ContactsOn.size(); i++)
            if ( ((Contact)ContactsOn.get(i)).equals(contact) )
                ContactsOff.add( ContactsOn.remove(i) );
        
        Client.RepaintArea();
        
        for (int i = 0; i < OpenWindows.size(); i++)
            if ( ((TalkWindow)OpenWindows.get(i)).Contacts.contains(contact) )
                ((TalkWindow)OpenWindows.get(i)).SetContactOff(contact);
        
    }
    
    //receber novo contactos que o tinham adicionado
    public void SetnewContacts(Vector contacts) throws RemoteException {
        
        for (int i = 0; i < contacts.size(); i++)
            new ContactAcept( (String)contacts.get(i), this).setVisible(true);
    }
    
    //abrir janela de conversacao caso essa nao exista
    public void OpenTalkWindow(String contact){
        
        Vector Contacts = new Vector();
        Contacts.add(MyName);
        Contacts.add(contact);
        
        
        for (int i = 0; i < OpenWindows.size(); i++){
            int found = 0;
            if ( ((TalkWindow)OpenWindows.get(i)).Contacts.size()==Contacts.size() )
                for (int j = 0; j < Contacts.size(); j++)
                    if ( ((TalkWindow)OpenWindows.get(i)).Contacts.contains( Contacts.get(j) ) )
                        found++;
            
            if ( found==Contacts.size() ){
                //retaurar janela caso esteja minimizada
                ((TalkWindow)OpenWindows.get(i)).setExtendedState( 0 );
                return;
            }
            
        }
        
        //abrir janela se ja nao estiver aberta
        new TalkWindow(Contacts, OpenWindows).setVisible(true);
        ((TalkWindow)OpenWindows.lastElement()).SetImage( Client.GetImage() );
        
    }
    
    //coloar mensagem numa janela
    public void SetMessage(Vector Contacts, Vector Message) throws RemoteException {
        
        //procurar se a janela ja existe
        for (int i = 0; i < OpenWindows.size(); i++){
            int found = 0;
            if ( ((TalkWindow)OpenWindows.get(i)).Contacts.size()==Contacts.size() )
                for (int j = 0; j < Contacts.size(); j++)
                    if ( ((TalkWindow)OpenWindows.get(i)).Contacts.contains( Contacts.get(j) ) )
                        found++;
            
            if ( found==Contacts.size() ){
                ((TalkWindow)OpenWindows.get(i)).SetMessage( (String)Contacts.get(0), Message );
                ((TalkWindow)OpenWindows.get(i)).setExtendedState( 0 );
                return;
            }
            
        }
        
        String contact = (String)Contacts.get(0);
        if ( !contact.equals(MyName) ){
            Contacts.remove( MyName );
            Contacts.add(0, MyName);
        }
        
        //se nao existe abre nova janela
        new TalkWindow(Contacts, OpenWindows).setVisible(true);
        ((TalkWindow)OpenWindows.lastElement()).SetImage( Client.GetImage() );
        ((TalkWindow)OpenWindows.lastElement()).SetMessage( contact, Message );
        
    }
    
    public void SetFile(String Name, File file) throws RemoteException {
        
        for (int i = 0; i < OpenWindows.size(); i++){
            if ( ((TalkWindow)OpenWindows.get(i)).Contacts.size()==2 )
                if ( ((TalkWindow)OpenWindows.get(i)).Contacts.contains( Name ) ){
                ((TalkWindow)OpenWindows.get(i)).SetFile( file );
                ((TalkWindow)OpenWindows.get(i)).setExtendedState( 0 );
                return;
                }
        }
        
        Vector Contacts = new Vector();
        Contacts.add( MyName );
        Contacts.add( Name );
        new TalkWindow(Contacts, OpenWindows).setVisible(true);
        ((TalkWindow)OpenWindows.lastElement()).SetImage( Client.GetImage() );
        ((TalkWindow)OpenWindows.lastElement()).SetFile( file );
        
    }
    
    public void AceptUpload(String Name) throws RemoteException {
        
        for (int i = 0; i < OpenWindows.size(); i++){
            if ( ((TalkWindow)OpenWindows.get(i)).Contacts.size()==2 )
                if ( ((TalkWindow)OpenWindows.get(i)).Contacts.contains( Name ) ){
                ((TalkWindow)OpenWindows.get(i)).AceptUpload();
                ((TalkWindow)OpenWindows.get(i)).setExtendedState( 0 );
                return;
                }
        }
        
        Vector Contacts = new Vector();
        Contacts.add( MyName );
        Contacts.add( Name );
        new TalkWindow(Contacts, OpenWindows).setVisible(true);
        ((TalkWindow)OpenWindows.lastElement()).SetImage( Client.GetImage() );
        ((TalkWindow)OpenWindows.lastElement()).AceptUpload();
        
    }
    
    public void CancelUpload(String Name) throws RemoteException {
        
        for (int i = 0; i < OpenWindows.size(); i++){
            if ( ((TalkWindow)OpenWindows.get(i)).Contacts.size()==2 )
                if ( ((TalkWindow)OpenWindows.get(i)).Contacts.contains( Name ) ){
                ((TalkWindow)OpenWindows.get(i)).CancelUpload();
                ((TalkWindow)OpenWindows.get(i)).setExtendedState( 0 );
                return;
                }
        }
        
        Vector Contacts = new Vector();
        Contacts.add( MyName );
        Contacts.add( Name );
        new TalkWindow(Contacts, OpenWindows).setVisible(true);
        ((TalkWindow)OpenWindows.lastElement()).SetImage( Client.GetImage() );
        ((TalkWindow)OpenWindows.lastElement()).CancelUpload();
        
    }
    
    public void SetFileBuffer(String Name, String buffer) throws RemoteException {
        
        for (int i = 0; i < OpenWindows.size(); i++){
            if ( ((TalkWindow)OpenWindows.get(i)).Contacts.size()==2 )
                if ( ((TalkWindow)OpenWindows.get(i)).Contacts.contains( Name ) ){
                ((TalkWindow)OpenWindows.get(i)).SetFileBuffer(buffer);
                return;
                }
        }
        
        Vector Contacts = new Vector();
        Contacts.add( MyName );
        Contacts.add( Name );
        new TalkWindow(Contacts, OpenWindows).setVisible(true);
        ((TalkWindow)OpenWindows.lastElement()).SetImage( Client.GetImage() );
        ((TalkWindow)OpenWindows.lastElement()).SetFileBuffer(buffer);
        
    }
    
    //obter imageicon do avatar
    public ImageIcon GetImageIcon() throws RemoteException {
        return Client.GetImageIcon();
    }
    
    //receber novo avatar de um contacot
    public void SetImageIcon(String Name, ImageIcon img) throws RemoteException {
        GetContact(Name).foto = img.getImage();
        Client.RepaintArea();
    }
    
    
}
