/*
 * ScrollArea.java
 *
 * Created on 1 de Julho de 2006, 0:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package client;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Font;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.Random;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

/**
 *
 * @author Eduardo
 */
public class ScrollArea extends JPanel{
    
    Rectangle VisibleWindow=this.getVisibleRect();
    
    ClientForm cf;
    Vector ContactsOn = null;
    Vector ContactsOff = null;
    Contact Selected = null;
    private Color SelectedColor = new Color(211,221,241);
    
    float alpha = 1.0f;
    
    int FontSize = 16;
    Font font = new Font("Papyrus", Font.BOLD, 16);
    private Color FontColor = Color.BLACK;
    
    int GridHoriz=50;
    int GridVert=30;
    boolean GridOn=false;
    /** Creates a new instance of ScrollArea */
    public ScrollArea() {
        this.setBackground(Color.WHITE);//new Color(244,225,147));
        
    }
    
    public void setContacts( Vector on, Vector off){
        ContactsOn = on;
        ContactsOff = off;
    }
    
    public void SetFather(ClientForm f){
        cf=f;
    }
    
    public void setAlphaComposite(float ac){
        alpha=ac;
    }
    public float getAlphaComposite(){
        return alpha;
    }
    
    public void setFont(String type, int style, int size){
        FontSize = size;
        font = new Font(type, style, size);
    }
    
    public Font getFont(){
        return font;
    }
    
    public void setFontColor(Color color){
        FontColor = color;
    }
    public Color getFontColor(){
        return FontColor;
    }
    
    public int getFontSize(){
        return FontSize;
    }
    
    public void setFontSize(int size){
        FontSize = size;
        font = new Font(font.getFamily(), font.getStyle(), size);
    }
    
    public void setFontFamily(String family){
        font = new Font(family, font.getStyle(), font.getSize());
    }
    
    public void setFontStyle(int style){
        font = new Font(font.getFamily(), style, font.getSize());
    }
    
    public void ScaleFontSize(double s){
        font = new Font(font.getFamily(), font.getStyle(), (int)(FontSize*s) );
    }
    
    public void setSelected(Contact selected){
        Selected = selected;
    }
    
    public void setSelectedColor(Color color){
        SelectedColor = color;
    }
    
    /*public void update( Graphics g ) {
        paint(g);
    }*/
    
    public void paint( Graphics g ) {
        
        VisibleWindow=this.getVisibleRect();
        
        if ( ContactsOn == null || ContactsOff == null ){
            g.setColor(new Color(238,238,238));
            g.fillRect(VisibleWindow.x, VisibleWindow.y, VisibleWindow.width, VisibleWindow.height);
            return;
        }
        
        g.setColor(this.getBackground());
        
        //GradientPaint gradient = new GradientPaint(VisibleWindow.x, VisibleWindow.y, Color.BLUE, VisibleWindow.x+VisibleWindow.width, VisibleWindow.y+VisibleWindow.height, Color.GREEN);
        //((Graphics2D)g).setPaint(gradient);
        //g.fillRect(0, 0, this.getWidth(), this.getHeight());
        g.fillRect(VisibleWindow.x, VisibleWindow.y, VisibleWindow.width, VisibleWindow.height);
        
        
        
        
        // Set alpha.  0.0f is 100% transparent and 1.0f is 100% opaque.
        //if (alpha!=1.0f)
        //    ((Graphics2D)g).setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, alpha));
        
        g.setColor(Color.BLUE);
        Font font = new Font("Papyrus", Font.BOLD, 12);
        
        
        g.setFont(font);
        g.drawString("OnLine("+ContactsOn.size()+")",5,15);
        
        
        Contact c;
        for (int i = 0; i < ContactsOn.size(); i++) {
            c = (Contact)ContactsOn.get(i);
            
            g.drawImage( c.foto!=null?c.foto:c.DefaultImage ,20, i*28+25, 25, 25, cf);
            if ( c.Blocked )
                g.drawImage( c.BlockImage ,33, i*28+38, 12, 12, cf);
            
            
            if ( c==Selected ){
                g.setColor(SelectedColor);
                g.fillRect( 50, i*28+25,
                        g.getFontMetrics().stringWidth( Selected.Name )+10, 25 );
                
            }
            g.setColor(Color.BLACK);
            g.drawString(c.Name,55,i*28+42);
            
        }        
        
        g.setColor(Color.BLUE);
        
        int start = 60 + ContactsOn.size()*28;
        g.drawString("OffLine("+ContactsOff.size()+")",5,start-15);
        
        for (int i = 0; i < ContactsOff.size(); i++) {
            c = (Contact)ContactsOff.get(i);
            
            g.drawImage( c.OffImage ,20, i*28+start, 25, 25, cf);
            if ( c.Blocked )
                g.drawImage( c.BlockImage ,33, i*28+start+13, 12, 12, cf);
            
            
            if ( c==Selected ){
                g.setColor(SelectedColor);
                g.fillRect( 50, i*28+start,
                        g.getFontMetrics().stringWidth( Selected.Name )+10, 25 );
                
            }
            g.setColor(Color.BLACK);
            g.drawString(c.Name,55,i*28+start+17);
            
        }
        
        
    }
    
    /*public Dimension getPreferredSize() {
        return size;
    }*/
    
}
