/*
 * TalkWindow.java
 *
 * Created on 29 de Outubro de 2006, 23:30
 */

package client;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.awt.Toolkit;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.Vector;
import javax.swing.JColorChooser;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

/**
 *
 * @author  Eduardo
 */
public class TalkWindow extends javax.swing.JFrame implements Runnable{
    
    public static Vector ContactsOn;
    public static File file = null;
    public static OutputStream out = null;
    public static File file_receive = null;
    long written = 0;
    long file_size = 0;
    public static boolean receiving = false;
    Thread t;
    
    public static void SetContactsOn(Vector v){
        ContactsOn=v;
    }
    
    //cliente associado a janela
    Vector Contacts;
    
    //vector com as janelas abertas
    Vector OpenWindows;
    
    //
    public static String MyClientAcept = "";
    
    
    //usado para adicao de estilos de texot
    StyledDocument doc;
    Style style;
    
    //inicializar tipo de letra
    String font_family = "Arial";
    Color font_color = Color.BLUE;
    int font_size = 14;
    boolean bold = true;
    boolean italic = false;
    
    
    /** Creates new form TalkWindow */
    public TalkWindow( Vector c, Vector v) {
        initComponents();
        
        // Get all font family names
        GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
        String fontNames[] = ge.getAvailableFontFamilyNames();
        
        // Iterate the font family names
        for (int i=0; i<fontNames.length; i++) {
            this.FontFamilyName.addItem(fontNames[i]);
        }
        
        String font_family = "Bookman Old Style";
        FontFamilyName.setSelectedItem(font_family);
        FontStyle.setSelectedItem("Negrito");
        this.FontColor.setBackground(font_color);
        this.FontSize.setText(""+font_size);
        
        SetFontAtributes();
        
        ((DrawImages)ContactImage).SetFather(this);
        this.ScrollPane.getHorizontalScrollBar().setEnabled(false);
        ((DrawImages)ContactImage).SetScroll(this.ScrollPane);
        Contacts = c;
        String title = "Conversacao com ";
        for (int i = 1; i < Contacts.size(); i++){
            title += (String)Contacts.get(i) +
                    (i!=Contacts.size()-1?", ":"");
            ((DrawImages)ContactImage).AddImage(
                    GetContact( (String)Contacts.get(i) ).foto );
        }
        
        
        this.setTitle( title );
        
        //adicionar nova janela criada
        OpenWindows = v;
        OpenWindows.add(this);
        
        //inicializar avatars
        ((ImagePanel)Image).SetFather(this);
        
        Image.setPreferredSize( new Dimension(96, 96) );
        Image.setSize(96,96);
        ((ImagePanel)Image).repaint();
        
    }
    
    public void SetImage(Image img){
        //colocar avatar
        ((ImagePanel)Image).foto = img;
    }
    
    public void SetFile( File f ){
        file_receive = f;
        new AceptDownload(this, f).setVisible(true);
    }
    
    public void SetFileBuffer( String buffer ){
        written += buffer.length();
        for (int i = 0; i < buffer.length(); i++)
            try {
                out.write( (int)buffer.charAt(i) );
                if ( written == file_receive.length() )
                    out.close();
                
            } catch (IOException ex) {
                ex.printStackTrace();
            }
    }
    
    public void AceptDownload(){
        try {
            written = 0;
            out = new FileOutputStream("c:\\file.txt");
            ClientAcept sa;
            try {
                sa = (ClientAcept)Naming.lookup(
                        GetContact( (String)Contacts.get(1) ).ClientAcept );
                sa.AceptUpload( (String)Contacts.get(0) );
            } catch (Exception ex) {}
            
            
            
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        }
        
    }
    
    public void CancelDownload(){
        file_receive = null;
        ClientAcept sa;
        try {
            sa = (ClientAcept)Naming.lookup(
                    GetContact( (String)Contacts.get(1) ).ClientAcept );
            sa.CancelUpload( (String)Contacts.get(0) );
        } catch (Exception ex) {}
        
    }
    
    public void AceptUpload(){
        //*lancar thread a enviar;
        t = new Thread(this);
        t.start();
    }
    
    public void CancelUpload(){
        if ( file!=null )
            t.stop();
        file = null;
    }
    
    
    public void SetMessage( String Name, Vector Message ){
        //envio de nova mensagem
        
        //estilo na primeira posicao do vector
        Style stl = style;
        DrawDefaultText(Name+" diz:");
        String s = TextArea.getText().replace("\n","");
        int ini=s.length();
        AppendText( /*"   " +*/
                ( (String)Message.get(1) ).replace("\n","\n   ") );
        s = TextArea.getText().replace("\n","");
        int fin=s.length();
        //alterar o texto que vai ser enviado
        doc = TextArea.getStyledDocument();
        doc.setCharacterAttributes(ini, fin, (Style)Message.get(0), true);
        
        style = stl;
        
    }
    
    //remover contacto da conversacao
    public void SetContactOff(String Name){
        
        if ( Contacts.size()>2 ){
            
            ((DrawImages)ContactImage).RemoveImagePos( Contacts.indexOf( Name ) );
            Contacts.remove(Name);
            
            String title = "Conversacao com ";
            for (int i = 1; i < Contacts.size(); i++)
                title += (String)Contacts.get(i) +
                        (i!=Contacts.size()-1?", ":"");
            
            
            this.setTitle( title );
            Style stl = style;
            DrawDefaultText("O contacto "+Name+" abandonou a conversa...");
            style = stl;
        }
        
    }
    
    
    
    //adicionar texto a ajenla
    public synchronized void AppendText(String str){
        //fazer seleccao no final de todo o texto existente
        TextArea.setSelectionStart(TextArea.getText().length());
        TextArea.setSelectionEnd(TextArea.getText().length());
        //adicionar linha de texto a janela
        TextArea.replaceSelection( str+"\n" );
    }
    
    
    //alterar o estilo de escrita de acordo com
    //alteracoes feitas
    public void SetFontAtributes(){
        doc = SendArea.getStyledDocument();
        SendArea.removeStyle("FontStyleAtrib");
        style = SendArea.addStyle("FontStyleAtrib", null);
        StyleConstants.setFontFamily(style, font_family);
        if ( bold )
            StyleConstants.setBold(style, true);
        if ( italic )
            StyleConstants.setItalic(style, true);
        StyleConstants.setFontSize(style, font_size);
        StyleConstants.setForeground(style, font_color);
        //atribuir estilo a todo o paragrafo de envio de mensagem
        SendArea.setParagraphAttributes(style, true);
    }
    
    //colocar uma linha de texto com um estilo predefinido
    public void DrawDefaultText(String msg){
        
        String s = TextArea.getText();
        s=s.replace("\n","");
        int ini=s.length();
        AppendText(msg);
        s = TextArea.getText();
        s=s.replace("\n","");
        int fin=s.length();
        
        
        doc = TextArea.getStyledDocument();
        style = TextArea.addStyle("FontStyleAtrib", null);
        StyleConstants.setFontFamily(style, "Arial");
        StyleConstants.setFontSize(style, 14);
        StyleConstants.setForeground(style, Color.BLACK);
        //alterar letra apenas nos caracters que pertencem a mensagem
        doc.setCharacterAttributes(ini, fin, TextArea.getStyle("FontStyleAtrib"), true);
        //TextArea.setParagraphAttributes(style, true);
    }
    
    //adicionar novo contacto a conversacao
    public void AddContact(String c){
        if ( !Contacts.contains( c ) ){
            Contacts.add(c);
            //adicionar o seu avatar a janeal
            ((DrawImages)ContactImage).AddImage(
                    GetContact( c ).foto );
        }
        
        String title = "Conversacao com ";
        for (int i = 1; i < Contacts.size(); i++)
            title += (String)Contacts.get(i) +
                    (i!=Contacts.size()-1?", ":"");
        
        this.setTitle( title );
    }
    
    //obter contacto pelo nome
    public Contact GetContact(String contact){
        for (int i = 0; i < ContactsOn.size(); i++)
            if ( ((Contact)ContactsOn.get(i)).Name.equals( contact ) )
                return (Contact)ContactsOn.get(i);
        
        return null;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        button1 = new java.awt.Button();
        jScrollPane2 = new javax.swing.JScrollPane();
        TextArea = new javax.swing.JTextPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        SendArea = new javax.swing.JTextPane();
        jLabel17 = new javax.swing.JLabel();
        FontFamilyName = new javax.swing.JComboBox();
        FontStyle = new javax.swing.JComboBox();
        jLabel19 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        FontSize = new javax.swing.JTextField();
        FontColor = new javax.swing.JButton();
        jLabel20 = new javax.swing.JLabel();
        button3 = new java.awt.Button();
        Image = new ImagePanel();
        ScrollPane = new javax.swing.JScrollPane();
        ContactImage = new DrawImages();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        button1.setLabel("Enviar");
        button1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button1ActionPerformed(evt);
            }
        });

        jScrollPane2.setViewportView(TextArea);

        SendArea.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                SendAreaKeyPressed(evt);
            }
            public void keyReleased(java.awt.event.KeyEvent evt) {
                SendAreaKeyReleased(evt);
            }
        });

        jScrollPane1.setViewportView(SendArea);

        jLabel17.setText("Tipo de Letra:");

        FontFamilyName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FontFamilyNameActionPerformed(evt);
            }
        });

        FontStyle.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Normal", "Negrito", "It\u00e1lico", "Negrito It\u00e1lico" }));
        FontStyle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FontStyleActionPerformed(evt);
            }
        });

        jLabel19.setText("Estilo:");

        jLabel18.setText("Tamanho:");

        FontSize.setText("16");
        FontSize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FontSizeActionPerformed(evt);
            }
        });

        FontColor.setBackground(new java.awt.Color(0, 0, 0));
        FontColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FontColorActionPerformed(evt);
            }
        });

        jLabel20.setText("Cor:");

        button3.setLabel("Adicionar");
        button3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button3ActionPerformed(evt);
            }
        });

        Image.setMaximumSize(new java.awt.Dimension(96, 96));
        Image.setMinimumSize(new java.awt.Dimension(96, 96));
        Image.setPreferredSize(new java.awt.Dimension(96, 96));
        org.jdesktop.layout.GroupLayout ImageLayout = new org.jdesktop.layout.GroupLayout(Image);
        Image.setLayout(ImageLayout);
        ImageLayout.setHorizontalGroup(
            ImageLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 96, Short.MAX_VALUE)
        );
        ImageLayout.setVerticalGroup(
            ImageLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout ContactImageLayout = new org.jdesktop.layout.GroupLayout(ContactImage);
        ContactImage.setLayout(ContactImageLayout);
        ContactImageLayout.setHorizontalGroup(
            ContactImageLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 407, Short.MAX_VALUE)
        );
        ContactImageLayout.setVerticalGroup(
            ContactImageLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 299, Short.MAX_VALUE)
        );
        ScrollPane.setViewportView(ContactImage);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel17)
                            .add(FontFamilyName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 126, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(29, 29, 29)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(FontStyle, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel19))
                        .add(24, 24, 24)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(FontSize, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel18))
                        .add(16, 16, 16)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel20)
                            .add(FontColor, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 391, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(Image, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(77, 77, 77))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, button1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, button3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, ScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 113, Short.MAX_VALUE))
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(ScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 208, Short.MAX_VALUE)
                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 208, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(button3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(layout.createSequentialGroup()
                                .add(jLabel17)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(FontFamilyName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(layout.createSequentialGroup()
                                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                            .add(jLabel19)
                                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                                .add(jLabel18)
                                                .add(jLabel20)))
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                            .add(FontStyle, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                            .add(FontSize, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                                    .add(layout.createSequentialGroup()
                                        .add(20, 20, 20)
                                        .add(FontColor, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)))
                        .add(29, 29, 29)
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 68, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(Image, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(button1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 36, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void button3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button3ActionPerformed
// TODO add your handling code here:
        new SelectContact(this, Contacts);
    }//GEN-LAST:event_button3ActionPerformed
    
    private void SendAreaKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_SendAreaKeyReleased
// TODO add your handling code here:
        if ( !evt.isShiftDown() && evt.getKeyCode()==evt.VK_ENTER ){
            SendArea.setText("");
            return;
        }
    }//GEN-LAST:event_SendAreaKeyReleased
    
    private void FontColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FontColorActionPerformed
// TODO add your handling code here:
        Color aux = font_color;
        //alteracao de cor da letra
        font_color = JColorChooser.showDialog(this,
                "Escolher cor do Texto",
                FontColor.getBackground());
        if (font_color == null)
            font_color = aux;
        this.FontColor.setBackground(font_color);
        SetFontAtributes();
    }//GEN-LAST:event_FontColorActionPerformed
    
    private void FontSizeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FontSizeActionPerformed
// TODO add your handling code here:
        //alteracao do tamanho da letra
        int size = 0;
        try{
            size = Integer.parseInt( FontSize.getText() );
            font_size=size;
        }catch(NumberFormatException e){
            FontSize.setText( ""+font_size );
            Toolkit.getDefaultToolkit().beep();
        }
        SetFontAtributes();
    }//GEN-LAST:event_FontSizeActionPerformed
    
    private void FontStyleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FontStyleActionPerformed
// TODO add your handling code here:
        if (FontStyle.getSelectedIndex()==0){
            bold = false;
            italic = false;
        }else if (FontStyle.getSelectedIndex()==1){
            bold = true;
            italic = false;
        }else  if (FontStyle.getSelectedIndex()==2){
            bold = false;
            italic = true;
        }else{
            bold = true;
            italic = true;
        }
        SetFontAtributes();
    }//GEN-LAST:event_FontStyleActionPerformed
    
    private void FontFamilyNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FontFamilyNameActionPerformed
// TODO add your handling code here:
        //alterar o tipo de letra
        font_family = (String)FontFamilyName.getSelectedItem();
        SetFontAtributes();
    }//GEN-LAST:event_FontFamilyNameActionPerformed
    
    private void SendAreaKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_SendAreaKeyPressed
// TODO add your handling code here:
        //verificar se foi feita uma mudanca de linha
        if ( evt.isShiftDown() && evt.getKeyCode()==evt.VK_ENTER ){
            SendArea.replaceSelection("\n");
            return;
        }
        //verificar se foi pressionado enter para envio da mensagem
        if (evt.getKeyCode()==evt.VK_ENTER)
            button1ActionPerformed(null);
    }//GEN-LAST:event_SendAreaKeyPressed
    
    private void button1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button1ActionPerformed
// TODO add your handling code here:
        String texto = SendArea.getText();
        if ( texto == "" || texto == null )
            return;
        
        try{
            
            Vector Message = new Vector();
            Message.add(style);
            Message.add( SendArea.getText() );
            
            //mostrar mensagem caso o contacto esteja offline
            if ( Contacts.size()==2 && !ContactsOn.contains(
                    new Contact( (String)Contacts.lastElement(),false,null)) ){
                Style stl = style;
                DrawDefaultText("O contacto est offline...");
                style = stl;
            }else{
                String ClientAcept="";
                for (int i = 0; i < Contacts.size(); i++)
                    
                    try{
                        
                        ClientAcept="";
                        if (i==0)
                            ClientAcept = MyClientAcept;
                        else
                            ClientAcept = GetContact( (String)Contacts.get(i) ).ClientAcept;
                        //enviar mensagem para o contacto
                        ClientAcept sa = (ClientAcept)Naming.lookup(
                                ClientAcept );
                        sa.SetMessage( Contacts, Message );
                        
                    }catch(Exception ex){
                        JOptionPane.showMessageDialog(this,
                                ClientAcept, "ERRO2", JOptionPane.ERROR_MESSAGE);
                        ex.printStackTrace();
                    }
                
            }
            //limpar janela de envio
            SendArea.setText("");
            
            /*if ( this.SendSocket == null ){
                SendSocket = new Socket(IP, 10009);
             
            }*/
            
            //SendSocket = new Socket( GetIP(), 10002);
            //outToServer = new DataOutputStream( SendSocket.getOutputStream() );
            
            //nome do nosso envio de mensagem com letra predefenida
            //DrawDefaultText(MainClient.GetName()+" diz:");
            
            
            /*
             
            doc = TextArea.getStyledDocument();
            style = TextArea.addStyle("FontStyleAtrib", null);
            StyleConstants.setFontFamily(style, font_family);
            if ( bold )
                StyleConstants.setBold(style, true);
            if ( italic )
                StyleConstants.setItalic(style, true);
            StyleConstants.setFontSize(style, font_size);
            StyleConstants.setForeground(style, font_color);
             
            String s = TextArea.getText().replace("\n","");
            int ini=s.length();
            AppendText(texto);
            s = TextArea.getText().replace("\n","");
            int fin=s.length();
            //alterar o texto que vai ser enviado
            doc.setCharacterAttributes(ini, fin, TextArea.getStyle("FontStyleAtrib"), true);
             
            //substituir mudancas de linha
            texto = texto.replaceAll("\n", "");
            //MainClient.sout(texto);
            //escrever dados para o outro cliente(letra e menssagem)
            //outToServer.writeBytes( ProcessFont()+texto+"\n" );
             
             
            //outToServer.close();
            //SendSocket.close();
             
            //fazer scroll para o fim da janela
            this.jScrollPane2.getVerticalScrollBar().setValue(
                    jScrollPane2.getVerticalScrollBar().getMaximum() );
             
            //limpar janela de envio
            SendArea.setText("");
             *
             *
             **/
            
            
            /*
             *
             try{
             
            if ( file!=null || Contacts.size()!=2 || receiving)
                return;
            //abrir janela de escolha de ficheiros
            JFileChooser chooser = new JFileChooser(System.getProperty("user.dir"));
            int returnValue = chooser.showOpenDialog(this);
            //verificar se nao foi devolvido um ficheiro
            if( (returnValue == chooser.ERROR_OPTION ) || (returnValue==chooser.CANCEL_OPTION)  )
                return;
             
            //obter localizacao do ficheiro
            String FilePath = chooser.getSelectedFile().getPath();
             
            file = new File(FilePath);
             
            // Get the number of bytes in the file
            long length = file.length();
             
            ClientAcept sa = (ClientAcept)Naming.lookup(
                    GetContact( (String)Contacts.get(1) ).ClientAcept );
             
             
            sa.SetFile( (String)Contacts.get(0), file );
             
             
        }catch(Exception e){
            new JOptionPane().showMessageDialog(this, e.getMessage(), "ERRO3", JOptionPane.ERROR_MESSAGE);
        }
             *
             */
            
        }catch(Exception e){
            new JOptionPane().showMessageDialog(this, e.getMessage(), "ERRO4", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_button1ActionPerformed
    
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
// TODO add your handling code here:
        if ( OpenWindows!=null )
            OpenWindows.remove(this);
        
        /*try{
            if ( SendSocket!=null )
                SendSocket.close();
            if ( outToServer!=null )
                outToServer.close();
         
        }catch(Exception e){
            JOptionPane.showMessageDialog(this, e.getMessage(), "ERRO", JOptionPane.ERROR_MESSAGE);
        }*/
        
    }//GEN-LAST:event_formWindowClosed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new TalkWindow(new Vector(),  new Vector()).setVisible(true);
            }
        });
    }
    
    public void run() {
        
        if ( file==null )
            return;
        
        try{
            
            InputStream is = new FileInputStream(file);
            while(true){
                
                int count = 0;
                String buffer = "";
                int rd = 0;
                while ( count<100 ){
                    rd = is.read();
                    if ( rd==-1 )
                        break;
                    buffer+=is.read();
                    count++;
                }
                
                ClientAcept sa = (ClientAcept)Naming.lookup(
                        GetContact( (String)Contacts.get(1) ).ClientAcept );
                sa.SetFileBuffer( (String)Contacts.get(0), buffer );
                if ( rd==-1 )
                    break;
                
                t.sleep(1000);
                
            }
            
        }catch(Exception e){}
        
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel ContactImage;
    private javax.swing.JButton FontColor;
    private javax.swing.JComboBox FontFamilyName;
    private javax.swing.JTextField FontSize;
    private javax.swing.JComboBox FontStyle;
    private javax.swing.JPanel Image;
    private javax.swing.JScrollPane ScrollPane;
    private javax.swing.JTextPane SendArea;
    private javax.swing.JTextPane TextArea;
    private java.awt.Button button1;
    private java.awt.Button button3;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    // End of variables declaration//GEN-END:variables
    
}
