/*
 * Client.java
 *
 * Created on 11 de Novembro de 2006, 18:39
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package server;

import java.io.Serializable;
import java.util.Vector;

/**
 *
 * @author Eduardo
 */
public class Client implements Serializable {
    
    //vector estatico com os clientes que estao online
    public static Vector Online = new Vector();
    public static final char Sep = ':';
    
    protected String Name;
    protected String IP;
    protected int port;
    
    //vector com os ponteiros para os outros cleintes que sao contactos
    protected Vector Contacts = new Vector();
    //ponteiros para os contactos bloqueados
    protected Vector Blocked = new Vector();
    //contactos que adicionaram este contacto a sua lista mas este nao os tem
    protected Vector newContacts = new Vector();
    
    /** Creates a new instance of Client */
    public Client(String nm, String ip) {
        Name = nm;
        IP = ip;
    }
    
    /////////////////////////////////////////selectores/////////////////////////
    public static Vector Online(){
        return Online;
    }
    
    
    public String GetName(){
        return Name;
    }
    
    public String GetIP(){
        return IP;
    }
    
    public int GetPort(){
        return port;
    }
    
    public Vector GetContacts(){
        return Contacts;
    }
    
    public void SetName(String nm){
        Name = nm;
    }
    
    public void SetIP(String ip){
        IP = ip;
    }
    
    public void SetPort(int port){
        this.port = port;
    }    
    
    ///////////////////////////////////////////////metodos//////////////////////
    
    //adicionar um contacto que este nao o continha
    public void AddnewContact(String contact){
        //if ( newContacts == null )
        //    newContacts = new Vector();
        newContacts.add(contact);
        //newContacts.trimToSize();
    }
    
    //remover contacto que este nao o continha
    public void RemovenewContact(String contact){
        //if ( newContacts==null )
        //    return;
        
        for (int i = 0; i < newContacts.size(); i++)
            if ( ((String)newContacts.get(i)).equals(contact) )
                newContacts.remove(i);
        
        //if ( newContacts.size()>0 )
        //    newContacts.trimToSize();
        //else
        //    newContacts = null;
    }
    
    //limpar contactos que este nao os continha
    public void ClearnewContacts(){
        newContacts.clear();
    }
    
    //obter contactos que este nao os continha
    public Vector GetnewContacts(){
        return newContacts;
    }
    
    //verificar se o cliente ja tem o cliente adicionado
    public boolean ContainsContact(Client c){        
        return Contacts.contains(c);        
    }
    
    //obter posicao a que contacto esta
    public int IndefOfContact(String Name){
        
        for (int i = 0; i < Contacts.size(); i++)
            if ( ((Client)Contacts.get(i)).equals( Name ) )
                return i;
        return -1;
        
    }
    
    //adicionar novo contacto e remover cado esteja para aviso
    public void AddContact(Client c){
        
        if ( !ContainsContact(c) ){
            Contacts.add(c);
            RemovenewContact( c.GetName() );
        }else
            return;
        
        Contacts.trimToSize();
        /*boolean AuxBlocked []= new boolean[ Contacts.size() ];
        AuxBlocked[Contacts.size()-1] = false;        
        for (int i = 0; i < Contacts.size()-1; i++)
            AuxBlocked[i] = Blocked[i];
        Blocked = AuxBlocked;*/
        
    }
    
    //remover contacto e tb caso este esteja para aviso
    public boolean RemoveContact(Client c){
        
        /*int pos = -1;
        for (int i = 0; i < Contacts.size(); i++)
            if ( ((Client)Contacts.get(i)).equals( Name ) )
                pos = i;
        
        if ( pos == -1 )
            return null;*/
        
        //for (int i = pos; i < Contacts.size()-1; i++)
        //    Blocked[i] = Blocked[i+1];
        Blocked.remove(c);
        RemovenewContact( c.GetName() );
        return Contacts.remove(c);
    }
    
    //verificar se um contacto esta bloquear
    public boolean IsBlocked(Client c){
        
        if ( Blocked.contains(c) || !Contacts.contains(c) )
            return true;
        return false;
        //try{
            //return Blocked[Contacts.indexOf(c)];
        //return !Contacts.contains(c);
        //}catch(Exception e){
        //    return true;
        //}
    }
    
    //bloquear contacto se este estiver desbloqueado e
    //desbloquear contacto se este estiver bloqueado
    public boolean Block(Client c){
        int index = Contacts.indexOf(c);
        if ( index==-1 )
            return false;
        
        //se estiver bloqueado retira-o da lista de bloqueados
        if ( Blocked.contains(c) ){
            Blocked.remove(c);
            return false;
        }
        
        //se nao estiver bloqueado adiciona-o da lista de bloqueados
        Blocked.add(c);
        return true;
        /*if ( Blocked[index] )
            Blocked[index]=false;
        else
            Blocked[index]=true;
        
        return Blocked[index];*/
            
    }
     
    //obter todos os seus contactos e o seu estado
    public Vector GetContactsStatus(){
        Vector status = new Vector();
        
        for (int i = 0; i < Contacts.size(); i++){
            //1 byte corresponde ao seu estado
            // "<"-offline e ">"-online
            String state = "<";
            //2 byte correponde se ele esta bloqueado
            // "u"-desbloqueado e "b"-bloqueado
            String block = "u";            
            if ( Online.contains(Contacts.get(i)) && !((Client)Contacts.get(i)).IsBlocked(this) )
                state = ">";
            if ( IsBlocked( (Client)Contacts.get(i) ) )
                block = "b";
            
            //enviar a mensagem em forma de string
            status.add( state+block+((Client)Contacts.get(i)).toString() );
        }
        
        status.trimToSize();
        return status;
    }
    
    //obter url para porcura de um objecto do cliente pelo servidor
    public String GetLookupServerAcept(){
        return "//"+IP+":"+port+"/ServerAcept";
    }
    
    //obter url para porcura de um objecto do cliente por outro cliente
    public String GetLookupClientAcept(){
        return "//"+IP+":"+port+"/ClientAcept";
    }    
    
    //devolver contacto em forma de texto
   public String toString(){
       return GetIP()+Sep+GetPort()+Sep+GetName();
   } 
    
    
    public boolean equals(Object o){
        if ( o instanceof Client && ((Client)o).GetName().equals(Name) )
            return true;
        if ( o instanceof String && ((String)o).equals(Name) )
            return true;
        return false;        
    }
    
}
