/*
 * MainServer.java
 *
 * Created on 9 de Novembro de 2006, 15:54
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package server;

import client.ServerAcept;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.server.ServerNotActiveException;
import java.rmi.server.UnicastRemoteObject;
import java.security.Permission;
import java.util.Vector;

/**
 *
 * @author Administrator
 */
public class MainServer extends UnicastRemoteObject implements ServerMethods, Runnable {
    
    //clientes guardados no servidor
    Vector AllClients;
    //janela do servidor
    ServerForm Server;
    //url usado para registar o objecto
    String name = "//localhost:10000/ServerMethodsServer";
    
    Thread t;
    
    //obter um cliente apartir do seu nome
    public Client GetClient(String Name){
        
        for (int i = 0; i < AllClients.size(); i++)
            if ( ((Client)AllClients.get(i)).equals( Name ) )
                return (Client)AllClients.get(i);
        
        return null;
        
    }
    
    /**
     * Creates a new instance of MainServer
     */
    public MainServer(ServerForm form, Vector clients) throws RemoteException {
        Server = form;
        AllClients = clients;
        t = new Thread(this);
    }
    
    //parar servidor
    public void StopServer(){
        try {
            //retirar o bojecto do registo
            Naming.unbind(name);
            t.stop();
        } catch (Exception e) {
            Server.AppendMessage( e.getMessage() );
        }
        
        try{
            //guardar todos os clientes no servidor
            ObjectOutputStream fo = new ObjectOutputStream(new FileOutputStream("vector.tmp", false));
            fo.writeObject(AllClients);
            fo.flush();
            fo.close();
        }catch(Exception e){
            Server.AppendMessage( e.getMessage() );
        }
        
        System.exit(0);
    }
    
    public void StartServer(){
        
        try {
            java.rmi.registry.LocateRegistry.createRegistry(10000);
        } catch (RemoteException ex) {
            Server.AppendMessage( "Nao  posivel fazer o registry com o porto 10000\n" );
            ex.printStackTrace();
        }
        
        System.setSecurityManager(new RMISecurityManager() {
            public void checkConnect(String host, int port) {}
            public void checkConnect(String host, int port, Object context) {}
            public void checkPermission(Permission perm) {}
        });
        
        
        try{
            //ler clientes guardados no disco para o vector
            ObjectInputStream fi = new ObjectInputStream(new FileInputStream("vector.tmp"));
            AllClients = (Vector) fi.readObject();
            fi.close();
            //mostrar clientes
            Server.AppendMessage( "Registered Clients: \n" );
            for (int i = 0; i < AllClients.size(); i++){
                Client c = (Client)AllClients.get(i);
                if ( Client.Online().contains(c) )
                    Server.AddClient( ">"+c.GetName() );
                else
                    Server.AddClient( "<"+c.GetName() );
                Server.AppendMessage( ((Client)AllClients.get(i)).toString() );
            }
            
            //AllClients.clear();
            
        }catch(Exception e){
            Server.AppendMessage( e.getMessage() );
            AllClients = new Vector();
        }
        
        
        
        
        
        try {
            //registar este objecto
            Naming.rebind(name,this);
            Server.AppendMessage( "Servidor Ligado: " + name + "\n" );
        } catch (Exception e) {
            Server.ShowMessage( e.getMessage() );
            e.printStackTrace();
        }
        
        //comecar thread de verificacao se os clientes estam online
        t.start();
        
    }
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
    }
    
    //registo de clientes
    public void Register(String Name) throws RemoteException {
        try {
            
            //se o cliente inda nao estiver registado entao regista-o
            if ( GetClient( Name ) == null ){
                AllClients.add( new Client(Name, getClientHost()) );
                
                if ( Server!=null ){
                    Server.AppendMessage( "Novo registo de : "+Name );
                }
            }else
                if ( Server!=null )
                    Server.AppendMessage( "O cliente ["+Name+"] ja tinha sido registado" );
            
        } catch (ServerNotActiveException ex) {
            Server.ShowMessage(ex.getMessage());
            ex.printStackTrace();
        }
    }
    
    //obter todos os contactos associados a um cliente
    public Vector GetContacts(String Name) throws RemoteException {
        
        try {
            //obter o cliente que esta a fazer o pedido
            Client on = GetClient( Name );
            if ( on==null )
                return null;
            else
                //se ele existir envia os sus contactos
                return on.GetContactsStatus();
            
            
        } catch (Exception ex) {
            Server.ShowMessage(ex.getMessage());
            ex.printStackTrace();
        }
        
        return null;
        
    }
    
    //verifica se um cliente est registado no servidor
    public boolean IsRegisted(String Name){
        return AllClients.contains( GetClient(Name) );
    }
   
    //metodo para aceitar a ligacao do cliente ficar online
    public boolean SetOnline(String Name, int port) throws RemoteException {
        
        try {
            
            //obter cliente k esta a fazer o pedido
            Client on = GetClient( Name );
            if ( on == null )
                return false;
            
            //guardar o seu ip
            on.SetIP( getClientHost() );
            //guardar a porta usada
            on.SetPort(port);
            
            Server.AppendMessage( on.toString()+"\n"+on.GetLookupClientAcept() );
            //se o cliente inda na estava online entao coloca-o
            if ( !Client.Online().contains(on) )
                Client.Online().add(on);
            
            //actualizar lista de clientes na janela do servidor
            Server.UpdateClients();
            
            //envio de nova entrada para todos os seus contactos
            Client c;
            for (int i = 0; i < on.GetContacts().size(); i++) {
                c = (Client)on.GetContacts().get(i);
                //se o contacto nao esta online ou bloqueado nao  avisado da entrada
                if ( !Client.Online().contains(c) || on.IsBlocked( c ) )
                    continue;
                else{
                    
                    try{
                        ServerAcept sa = (ServerAcept)Naming.lookup( c.GetLookupServerAcept() );                        
                        //avisar da sua entrada aos contactos
                        sa.SetContactOn( on.GetName(), on.GetLookupClientAcept() );
                    }catch(Exception ex){}
                    
                }
            }
            
            //verificar alguem tinha adicionado este cliente que entrou
            if ( on.GetnewContacts().size()>0 ){
                ServerAcept sa = (ServerAcept)Naming.lookup( on.GetLookupServerAcept() );
                //envia mensagem para aviso de querer tb adiciona-lo
                sa.SetnewContacts( on.GetnewContacts() );
                on.ClearnewContacts();
            }
            
            return true;
            
        } catch (Exception ex) {
            Server.AppendMessage( ex.getMessage() );
            ex.printStackTrace();
        }
        
        return false;
    }
    
    //saida de um cliente para offline
    public void SetOffline(String Name) throws RemoteException {
        
        Client on = GetClient( Name );
        if ( on == null )
            return;
        
        //remover o cliente dos que estam online
        Client.Online().remove(on);
        //actualizar lista de clientes na janela do servidor
        Server.UpdateClients();
        
        //envio de nova saida para todos os seus contactos
        Client c;
        for (int i = 0; i < on.GetContacts().size(); i++) {
            c = (Client)on.GetContacts().get(i);
            //se o contacto nao esta online ou bloqueado nao  avisado da saida
            if ( !Client.Online().contains(c) || on.IsBlocked( c ) )
                continue;
            else{
                
                try{
                    ServerAcept sa = (ServerAcept)Naming.lookup( c.GetLookupServerAcept() );
                    //avisar da sua saida aos contactos
                    sa.SetContactOff(Name);
                }catch(Exception ex){}
                
            }
        }
        
    }
    
    //adicionar contacto
    public boolean AddContact(String MyName, String Contact) throws RemoteException {
        
        //obter cliente k faz o pedido e nome do contacto a adicionar
        Client me = GetClient(MyName);
        Client nw = GetClient(Contact);
        if ( me == null || nw == null )
            return false;
        
        try {
            
            //adicionar o novo contacto
            me.AddContact(nw);
            //se o contacto nao me tinha adicionado
            //avisa-o de o alguem o ter adicionado
            if ( !nw.GetContacts().contains(me) ){
                
                if ( !nw.GetnewContacts().contains(me) ){
                    nw.AddnewContact(MyName);
                    //se o contacto estiver online envia ja a mensagem
                    if ( Client.Online().contains( nw ) ){
                        ServerAcept sa = (ServerAcept)Naming.lookup( nw.GetLookupServerAcept() );
                        sa.SetnewContacts( nw.GetnewContacts() );
                        //se a mensagem foi enviada com sucesso entao
                        //pode-se limpar os contactos que o tinham adicionado
                        nw.ClearnewContacts();
                    }
                }
                
            }else if ( Client.Online().contains( nw ) ){
                ServerAcept sa = (ServerAcept)Naming.lookup( nw.GetLookupServerAcept() );
                sa.SetContactOn( MyName, me.GetLookupClientAcept() );
            }
            
        } catch (Exception ex) {}
        
        
        //devolve se o contacto esta online para o cliente que fez o pedido
        if ( !Client.Online().contains(nw) || !nw.GetContacts().contains(me) || nw.IsBlocked(me) )
            return false;
        else
            return true;
        
    }
    
    //remover contacto
    public boolean RemoveContact(String MyName, String Contact) throws RemoteException {
        
        //obter cliente k faz o pedido e nome do contacto a remover
        Client me = GetClient(MyName);
        Client rm = GetClient(Contact);
        if ( me == null || rm == null )
            return false;
        
        try{
            //remove contacto
            me.RemoveContact(rm);
            if ( Client.Online().contains( rm ) ){
                ServerAcept sa = (ServerAcept)Naming.lookup( rm.GetLookupServerAcept() );
                //assim que o contacto  removido  enviado que este est como offline
                sa.SetContactOff( MyName );
            }
            
        }catch(Exception ex){}
        
        return true;
    }
    
    //bloquear contacto
    public boolean BlockContact(String MyName, String Contact) throws RemoteException {
        
        //obter cliente k faz o pedido e nome do contacto a bloquear
        Client me = GetClient(MyName);
        Client blk = GetClient(Contact);
        if ( me == null || blk == null )
            return false;
        
        //verificar se o contacto foi mesmo bloqueado
        boolean blocked = me.Block(blk);
        
        try{
            
            if ( Client.Online().contains(blk) && blk.ContainsContact(me) ){
                ServerAcept sa = (ServerAcept)Naming.lookup( blk.GetLookupServerAcept() );
                //se o contacto que foi bloqueado envia ao contacto que este esta online
                if ( blocked ){
                    sa.SetContactOff( MyName );
                //se for desbloqueado envia que esta online
                }else{
                    sa.SetContactOn( MyName, me.GetLookupClientAcept() );
                }
            }
        }catch(Exception ex){}
        
        return blocked;
        
    }
    
    public void run() {
        
        while(true){
            
            //verificar se para todos os clientes online
            //deixou de estar online
            Client c;
            for (int i = 0; i < Client.Online().size(); i++) {
                try{
                    ServerAcept sa = (ServerAcept)Naming.lookup(
                            ((Client)Client.Online().get(i)).GetLookupServerAcept() );
                    if ( !sa.GetStatus() )
                        throw new Exception("");
                    
                }catch(Exception ex1){
                    //se nao houve licaao  enviado para todos que o cliente ficou offline
                    try {
                        SetOffline( ((Client)Client.Online().get(i)).GetName() );
                    } catch (RemoteException ex2) {}
                }
                
            }
            
            //repetir accao de 5 em 5s
            try {
                t.sleep(5000);
            } catch (Exception ex) {}
            
            
        }
        
    }

    //obter url para procura do objecto para ligacao cliente a cliente
    public String GetClientAcept(String Name) throws RemoteException {
        Client c = GetClient(Name);
        if ( c == null )
            return null;
        return c.GetLookupClientAcept();
    }
    
    
}
