/*
 * ServerForm.java
 *
 * Created on 12 de Novembro de 2006, 15:41
 */

package server;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.rmi.RemoteException;
import java.util.Vector;
import javax.swing.JOptionPane;

/**
 *
 * @author  Eduardo
 */
public class ServerForm extends javax.swing.JFrame{
    
    //todos os clientes no servidor
    Vector AllClients = new Vector();
    //servidor principal
    MainServer s;
    /**
     * Creates new form ServerForm
     */
    public ServerForm() {
        initComponents();       
        
        try{
            //inicializar servidor
            s = new MainServer(this, AllClients);
            //comecar servidor
            s.StartServer();
            
        }catch(Exception e){
            ShowMessage( e.getMessage() );
            /*try {
                new MainServer(this).StartServer( new Vector() );
            } catch (RemoteException ex) {
                ex.printStackTrace();
            }*/
        }        
        
    }
    
    //mostrar mensagem de erro
    public void ShowMessage(String msg){
        JOptionPane.showMessageDialog(this, msg, "ERRO", JOptionPane.ERROR_MESSAGE);
    }
    
    //adicionar mensagem a area de log
    public void AppendMessage(String msg){
        LogArea.append(msg+"\n");
    }
    
    //adicionar cliente a lista da janela
    public void AddClient(String c){
        ClientList.add(c);
    }
    
    //actualizar estado de clientes
    public void UpdateClients(){
        
        ClientList.removeAll();
        //adicionar todos os clientes uqe estam no vector online
        for (int i = 0; i < Client.Online().size(); i++)
            AddClient( ">"+((Client)Client.Online().get(i)).GetName() );
        
        //adicionar contactos que nao estam online
        for (int i = 0; i < s.AllClients.size(); i++)
            if ( !Client.Online().contains( s.AllClients.get(i) ) )
                AddClient( "<"+((Client)s.AllClients.get(i)).GetName() );
        
    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        ClientList = new java.awt.List();
        jScrollPane1 = new javax.swing.JScrollPane();
        LogArea = new javax.swing.JTextArea();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        ClientList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ClientListMouseClicked(evt);
            }
        });

        LogArea.setColumns(20);
        LogArea.setRows(5);
        jScrollPane1.setViewportView(LogArea);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(ClientList, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 189, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 390, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 288, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, ClientList, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 288, Short.MAX_VALUE))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void ClientListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ClientListMouseClicked
// TODO add your handling code here:
        if ( evt.getClickCount()!=2 )
            return;
        
        //obter cliente apartir do seu nome que esta selecionado na lista
        Client me = s.GetClient( ClientList.getItem( ClientList.getSelectedIndex() ).substring(1) );
        //obter todos os contactos do lciente
        Vector c = me.GetContacts();
        if ( c==null )
            return;        
        
        NewJFrame j = new NewJFrame();
        j.setVisible(true);
        //mostrar estado de todos os contactos associados ao cleinte numa nova janela
        for (int i = 0; i < c.size(); i++) {
            if ( me.IsBlocked( (Client)c.get(i) ) )
                j.list1.add( "blocked - "+((Client)c.get(i)).GetName()+" "+((Client)c.get(i)).port );
            else
                j.list1.add( "unblocked - "+((Client)c.get(i)).GetName()+" "+((Client)c.get(i)).port );
        }
        
        ;
        
    }//GEN-LAST:event_ClientListMouseClicked
    
    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
// TODO add your handling code here:
        try{
            //parar servidor
            s.StopServer();
            //fechar janela
            this.dispose();            
        }catch(Exception e){
            ShowMessage( e.getMessage() );
        }
    }//GEN-LAST:event_formWindowClosing
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ServerForm().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.List ClientList;
    private javax.swing.JTextArea LogArea;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
    
}
